//============================================================================================================
//	$Id$
//
//	$Author$
//
//	$DateTime$
//============================================================================================================

#if defined(__LINUX__)
#include <cxxabi.h>
#include <cstdlib>
#endif
//#if defined(__HPUXI__)
//#include <acxx_demangle.h>
//#include <cstdlib>
//#endif

#include "lfc1/misc/cdemangler.hpp"

//#if defined(__LINUX__) || defined(__HPUXI__)
#if defined(__LINUX__)
using namespace std;
#endif
#if defined(__LINUX__)
using namespace abi;
#endif

namespace lfc1 { namespace misc {

///	@brief This function creates a CDemangler object.
///
///	@param[in]	apTypeName	The name to demangle.
///
CDemangler::CDemangler(const char* apTypeName) noexcept
//#if defined(__LINUX__) || defined(__HPUXI__)
#if defined(__LINUX__)
:	mpTypeName(apTypeName),
	mpDemangledTypeName(__cxa_demangle(mpTypeName, 0, 0, 0))
#else
:	mpTypeName(apTypeName)
#endif
{
}

///	@brief This function destroys a CDemangler object.
///
CDemangler::~CDemangler() noexcept
{
//#if defined(__LINUX__) || defined(__HPUXI__)
#if defined(__LINUX__)
	if (mpDemangledTypeName != nullptr)
	{
		free(mpDemangledTypeName);
	}
#endif
}

///	@brief This function obtains the demangled name.
///
///	@return The demangled name.
///
CDemangler::operator const char* () const noexcept
{
//#if defined(__LINUX__) || defined(__HPUXI__)
#if defined(__LINUX__)
	if (mpDemangledTypeName != nullptr)
	{
		return mpDemangledTypeName;
	}
#endif
	return mpTypeName;
}

} /* namespace misc */ } /* namespace lfc1 */

//============================================================================================================
//	End of Code
//============================================================================================================
